#! /home/song3/anaconda3/bin/python3

import numpy as np
# You need do a 
# pip install matplotlib
from matplotlib import pyplot as plt
import sys
import os.path
import warnings
warnings.simplefilter('ignore')

from scipy import stats
from scipy.fftpack import fft, ifft

# You need do a 
# pip install sounddevice
import sounddevice as sd
# You need do a 
# pip install soundfile
import soundfile as sf
# from matplotlib import dates,ticker

# from pandas.io.json import json_normalize
# from bson.objectid import ObjectId

# from pymongo import MongoClient
# db_client = MongoClient()
from scipy.signal import butter, lfilter, freqz

def butter_lowpass(cutoff, fs, order=5):
    nyq = 0.5 * fs
    normal_cutoff = cutoff / nyq
    b, a = butter(order, normal_cutoff, btype='low', analog=False)
    return b, a

def butter_lowpass_filter(data, cutoff, fs, order=5):
    b, a = butter_lowpass(cutoff, fs, order=order)
    y = lfilter(b, a, data)
    return y

def my_lowpass(data,fs,cutoff):
    f_data = fft(data) # calculate fourier transform (complex numbers list)
    
    plt.plot(abs(f_data))
    len_data = len(f_data)//2  # you only need half of the fft list (real signal symmetry)

    freqs = np.linspace(0,fs//2,len_data)
    filtered = []
    for i in range(len_data):
        if freqs[i] > cutoff:
            filtered.append(0)
        else:
            filtered.append(f_data[i])

    rev_filtered = filtered[::-1]
    rev_filtered.pop()
    rev_filtered.insert(0,f_data[len_data])
    rev_filtered = [data.conjugate() for data in rev_filtered]
    filtered = np.array(filtered + rev_filtered)
    # import pdb;pdb.set_trace()
    plt.plot(abs(filtered))
    plt.show()
    new_data = np.real(ifft(filtered))
    return new_data

if __name__ == "__main__":

    data,fs = sf.read("./test.flac")

    print("Sample rate: %d, shape of data: "%(fs),np.shape(data))
    # uncomment out the following two lines if you want to play the audio
    # sd.play(data, fs)
    # sd.wait()

    # take data from one of the two channels
    data = data.T[0]
    N = len(data)
    T = 1/fs

    # plot time domain 
    t_vec = np.arange(N)*T # time vector for plotting
    # plt.plot(t_vec,data)

    # f_data = fft(data) # calculate fourier transform (complex numbers list)
    # f_data = abs(f_data)
    # len_data = len(f_data)//2  # you only need half of the fft list (real signal symmetry)

    # freqs = np.linspace(0,fs//2,len_data)
    new_data = my_lowpass(data,fs,1e3)
    # new_data = butter_lowpass_filter(data,1e3,fs)
    sd.play(new_data, fs)
    sd.wait()



